//
//	simple test of Proxy class
//

#include <iostream>
#include <vector>
#include "Proxy.h"

#include <cassert>

extern Proxy<int> f(Proxy<int> &p);
Proxy<int> f(Proxy<int> &p) { return p; }

extern Proxy<int> pglob;
Proxy<int> pglob;

int main()
{
	{
		Proxy<int> i;
	}
	{
		Proxy<int> p0 = new int(999);
		assert(*p0 == 999);
		{
			Proxy<int> p1 = p0;
			Proxy<int> p2(p1);
			pglob = p2;
			{
				Proxy<int> p = f(pglob);
				pglob = p;
				*p = 888;
			}
		}
	}
	assert(*pglob == 888);

	return 0;
}
